//*****************************************************************************************************
//  1. t@C
//		DataFile.cpp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		f[^t@CNX̎
//----------------------------------------------------------------------------------------------------
//  3. l
//----------------------------------------------------------------------------------------------------
//  4. 
//		2007.08.09 S.Aizawa VK쐬
//*****************************************************************************************************

#include "StdAfx.h"
#include "DataFile.h"
#include "General.h"
#include "MMA_G.h"
#include <math.h>

// 077FD050-GYM961-0_007 2007/9/8 modified by yG ->
//static	char *gTitle = "No,Time,X-Axis(g),Y-Axis(g),Z-Axis(g),D-Temp(),X-Temp(),Y-Temp(),Z-Temp()\n";
static const char *gTitleMma = "No,Time(YYYY/MM/DD hh:mm:ss.tttt),X-Axis(g),Y-Axis(g),Z-Axis(g),D-Temp(),X-Temp(),Y-Temp(),Z-Temp()\n";
static const char *gTitleMme = "No,Time(YYYY/MM/DD hh:mm:ss.tttt),X-Axis(g),Y-Axis(g),Z-Axis(g)\n";
static const char *gTitleAsu = "No,Time(YYYY/MM/DD hh:mm:ss.tttt),X-Axis(g),Y-Axis(g),Z-Axis(g)\n";
// 077FD050-GYM961-0_007 2007/9/8 modified by yG ->
static const char *gTitleTemp = "No,Time(YYYY/MM/DD hh:mm:ss.tttt),D-Temp(),X-Temp(),Y-Temp(),Z-Temp()\n";

//*****************************************************************************************************
//  1. ֐
//		CDataFile::CDataFile
//----------------------------------------------------------------------------------------------------
//  2. @\
//		RXgN^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
CDataFile::CDataFile()
{
	// oϐ
	m_pTempDACM = NULL;
	m_pTempX = NULL;
	m_pTempY = NULL;
	m_pTempZ = NULL;
	m_pDataX = NULL;
	m_pDataY = NULL;
	m_pDataZ = NULL;
	m_nDataSize = 0;
	m_fSampleRate = 0;
	m_bReadAccelData = FALSE;
	m_bReadTempData = FALSE;
	m_nDownRate = 1;
	m_nAllocSize = 0;
	m_fAllocFactor = 1.0;
	m_nReadSize = 0;
	m_bTempOnly = FALSE;
	m_nDataType = 0;
}

//*****************************************************************************************************
//  1. ֐
//		CDataFile::~CDataFile
//----------------------------------------------------------------------------------------------------
//  2. @\
//		fXgN^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
CDataFile::~CDataFile()
{
	// oCif[^obt@
	FreeBuf();
}

//*****************************************************************************************************
//  1. ֐
//		CDataFile::ReadInfoFile
//----------------------------------------------------------------------------------------------------
//  2. @\
//		t@Cǂݍݏ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPCTSTR		pFilePath		[I] t@C̃pX
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	TRUEF@FALSEFG[
//*****************************************************************************************************
BOOL CDataFile::ReadInfoFile(LPCTSTR pFilePath)
{
	CStdioFile cFile;
	CMapStringToString cStringMap;
	CString sReadBuf;
	int nPos;
	CString sKey, sData;

	// t@CI[v
	if (!cFile.Open(pFilePath, CFile::modeRead | CFile::shareDenyNone)) {
		CGeneral::Alert("t@CJ܂B\n(%s)", pFilePath);
		return FALSE;
	}

	// eMAPɓǂݍ
	m_aDataFileName.RemoveAll();
	while (cFile.ReadString(sReadBuf)) {
		nPos = sReadBuf.Find('=');
		if (nPos > 0) {
			sKey = sReadBuf.Left(nPos);
			sData = sReadBuf.Mid(nPos + 1);

			if (sKey == "FILE")
				m_aDataFileName.Add(sData);
			else
				cStringMap.SetAt(sKey, sData);
		}
	}

	// MAPKvȏo
	m_fSampleRate = atof(cStringMap["SAMPLERATE"]);
	m_sDatPath = cStringMap["PATH"];
	m_nSensorId = atoi(cStringMap["SENSORID"]);
	m_nGain = atoi(cStringMap["GAIN"]);
	m_nCutoff = atoi(cStringMap["CUTOFF"]);
	m_nSensorIdx = atoi(cStringMap["SENSORIDX"]);
	m_SensorPos = cStringMap["SENSORCOSYS"];
	m_IssConfig = cStringMap["ISSCONFIG"];

	// JnԂNƕbɕ
	CString sStartTime = cStringMap["STARTTIME"];
	m_nStartYear = atoi(sStartTime.Mid(0, 4));
	m_nStartMonth = atoi(sStartTime.Mid(4, 2));
	m_nStartDay = atoi(sStartTime.Mid(6, 2));
	m_nStartMiliSecond = atoi(sStartTime.Mid(8, 8));
	m_fStartSecond = (double)m_nStartMiliSecond / 1000;

	// JnԂ\pJnԂɃZbg
	m_dStarttime.SetTime(m_nStartYear, m_nStartMonth, m_nStartDay, m_nStartMiliSecond);

	// g[^Ԃ擾
	if (!GetTotalTime())
		return FALSE;

	return TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CDataFile::GetTotalTime
//----------------------------------------------------------------------------------------------------
//  2. @\
//		g[^Ԑ擾
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	TRUEF@FALSEFG[
//*****************************************************************************************************
BOOL CDataFile::GetTotalTime()
{
	CFile cFile;
	CString sPathName;
	INFO_FILE_HEADER sHeader;

	m_nTotalDataSize = 0;

	// f[^t@Č[v
	int nFiles = (int)m_aDataFileName.GetSize();
	for (int i = 0; i < nFiles; i++) {
		// f[^t@CI[v
		sPathName.Format("%s\\%s", m_sDatPath, m_aDataFileName[i]);
		if (!cFile.Open(sPathName, CFile::modeRead | CFile::shareDenyNone)) {
			CGeneral::Alert("f[^t@CJ܂B\n(%s)", sPathName);
			return FALSE;
		}

		// f[^t@Cwb_ǂݍ
		cFile.Read(&sHeader, sizeof(sHeader));

		cFile.Close();

		// Sf[^t@C̃f[^Z
		m_nTotalDataSize += sHeader.nDataSize;
	}

	// g[^Ԃ߂
	m_fTotalSecond = m_nTotalDataSize / m_fSampleRate;

	return TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CDataFile::ReadDataFile
//----------------------------------------------------------------------------------------------------
//  2. @\
//		oCit@Cǂݍ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		int		nBeginTime			[I] ǂݍ݊Jnԁibj
//		int		nEndTime			[I] ǂݍݏIԁibj
//		BOOL	bReadAccelData		[I] xf[^ǂݍ݃tO
//		BOOL	bReadTempData		[I] xf[^ǂݍ݃tO
//		BOOL	bProgressBar		[I] vOXo[\tO
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	TRUEF@FALSEFG[
//*****************************************************************************************************
BOOL CDataFile::ReadDataFile(int nBeginTime, int nEndTime, BOOL bReadAccelData, BOOL bReadTempData, BOOL bProgressBar)
{
	CProgressBar cProgressBar;

	m_bReadAccelData = bReadAccelData;
	m_bReadTempData = bReadTempData;

	// oCif[^TCYݒ
	m_nDataSize = (int)((nEndTime - nBeginTime) * m_fSampleRate);
	m_nDataOffset = (int)((nBeginTime * 1000 - m_nStartMiliSecond) * m_fSampleRate / 1000);
	if (m_nDataOffset < 0)
		m_nDataOffset = 0;

	// oCif[^obt@m
	AllocBuf();

	if (bProgressBar) {
		// vOXo[\AʃXbhŃt@Cǂݍ
		return cProgressBar.ExecProcess("t@Cǂݍݒ", 10, this, ReadBinaryFileThread);
	} else {
		// f[^t@Cǂݍ
		return ReadBinaryFileThread2(NULL);
	}
}

//*****************************************************************************************************
//  1. ֐
//		CDataFile::ReadWriteDataFile
//----------------------------------------------------------------------------------------------------
//  2. @\
//		oCit@Cǂݍ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPCSTR	fname				[I] t@C
//		int		nBeginTime			[I] ǂݍ݊Jnԁibj
//		int		nEndTime			[I] ǂݍݏIԁibj
//		BOOL	bReadTempData		[I] xf[^ǂݍ݃tO
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	TRUEF@FALSEFG[
//*****************************************************************************************************
BOOL CDataFile::ReadWriteDataFile(LPCSTR fname, int nBeginTime, int nEndTime, BOOL bReadTempData)
{
	CProgressBar cProgressBar;

	m_bReadAccelData = TRUE;
	m_bReadTempData = bReadTempData;
	m_WriteFilePath = fname;
	m_nBeginTime = nBeginTime;

	// oCif[^TCYݒ
	m_nDataSize = (int)((nEndTime - nBeginTime) * m_fSampleRate);
	m_nDataOffset = (int)((nBeginTime * 1000 - m_nStartMiliSecond) * m_fSampleRate / 1000);

	// oCif[^obt@m
	AllocBuf();

	// vOXo[\AʃXbhŃt@Cǂݍ
	if (! cProgressBar.ExecProcess("t@Cǂݍݒ", 10, this, ReadBinaryFileThread))
		return FALSE;

	// vOXo[\AʃXbhŃt@Cǂݍ
	return cProgressBar.ExecProcess("t@Cݒ", 10, this, WriteBinaryFileThread);
}


//*****************************************************************************************************
//  1. ֐
//		CDataFile::ReadBinaryFileThread
//----------------------------------------------------------------------------------------------------
//  2. @\
//		t@Cǂݍ݃Xbh̓
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPVOID			pParam			[I] CDataFileNXւ̃|C^
//		CProgressBar	*pProgressBar	[I] vOXo[NXւ̃|C^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	TRUEF@FALSEFG[
//*****************************************************************************************************
BOOL CDataFile::ReadBinaryFileThread(LPVOID pParam, CProgressBar *pProgressBar)
{
	return ((CDataFile *)pParam)->ReadBinaryFileThread2(pProgressBar);
}

//*****************************************************************************************************
//  1. ֐
//		CDataFile::WriteBinaryFileThread
//----------------------------------------------------------------------------------------------------
//  2. @\
//		t@C݃Xbh̓
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPVOID			pParam			[I] CDataFileNXւ̃|C^
//		CProgressBar	*pProgressBar	[I] vOXo[NXւ̃|C^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	TRUEF@FALSEFG[
//*****************************************************************************************************
BOOL CDataFile::WriteBinaryFileThread(LPVOID pParam, CProgressBar *pProgressBar)
{
	return ((CDataFile *)pParam)->WriteBinaryFileThread2(pProgressBar);
}


//*****************************************************************************************************
//  1. ֐
//		CDataFile::ReadBinaryFileThread2
//----------------------------------------------------------------------------------------------------
//  2. @\
//		t@Cǂݍ݃Xbh̖{
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CProgressBar	*pProgressBar	[I] vOXo[NXւ̃|C^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	TRUEF@FALSEFG[
//*****************************************************************************************************
BOOL CDataFile::ReadBinaryFileThread2(CProgressBar *pProgressBar)
{
	CFile cFile;
	CString sPathName;
	INFO_FILE_HEADER sHeader;

	// ϐ
	int nSkipSize = m_nDataOffset + m_nReadSize;
	int nReadPtr = m_nReadSize;

	// f[^t@Č[v
	int nFiles = (int)m_aDataFileName.GetSize();
	for (int i = 0; i < nFiles; i++) {
		// f[^t@CI[v
		sPathName.Format("%s\\%s", m_sDatPath, m_aDataFileName[i]);
		if (!cFile.Open(sPathName, CFile::modeRead | CFile::shareDenyNone)) {
			CGeneral::Alert("f[^t@CJ܂B");
			return FALSE;
		}

		// f[^t@Cwb_ǂݍ
		cFile.Read(&sHeader, sizeof(sHeader));

		// ǂݔ΂TCYvZ
		int nDataSize = sHeader.nDataSize;
		int nReadOffset = 0;
		if (nSkipSize > 0) {
			int nSkip = min(nSkipSize, nDataSize);
			nSkipSize -= nSkip;
			nReadOffset += nSkip;
			nDataSize -= nSkip;
		}

		// ǂݔ΂If[^ǂݍ
		if (nSkipSize == 0) {
			int nRead = min(m_nDataSize - nReadPtr, nDataSize);
			if (nRead > 0) {
				// t@Cf[^ǂݍ
				double *pBuf = new double[nRead * 7];
				cFile.Seek(nReadOffset * 7 * sizeof(double), CFile::current);
				cFile.Read(pBuf, nRead * 7 * sizeof(double));

				// f[^obt@ɃRs[
				double *pBuf2 = pBuf;
				for (int j = 0; j < nRead; j++) {
					// ef[^obt@ɃRs[
					if (m_bReadTempData) {
						m_pTempDACM[nReadPtr] = *pBuf2++;
						m_pTempX[nReadPtr] = *pBuf2++;
						m_pTempY[nReadPtr] = *pBuf2++;
						m_pTempZ[nReadPtr] = *pBuf2++;
					} else
						pBuf2 += 4;

					if (m_bReadAccelData) {
						m_pDataX[nReadPtr] = *pBuf2++;
						m_pDataY[nReadPtr] = *pBuf2++;
						m_pDataZ[nReadPtr] = *pBuf2++;
					} else
						pBuf2 += 3;

					// vOXo[XV
					if (pProgressBar != NULL) {
						if (!pProgressBar->SetProgress(nReadPtr * 10 / m_nDataSize + 1)) {
							// f[^t@CN[Y
							cFile.Close();

							delete [] pBuf;
							return FALSE;
						}
					}

					nReadPtr++;
				}

				delete [] pBuf;
			}
		}

		// f[^t@CN[Y
		cFile.Close();

		// KvȃTCYǂݍ񂾂I
		if (nReadPtr >= m_nDataSize)
			break;
	}

	// ǂݍݍς݂̃TCYۑ
	m_nReadSize = nReadPtr;

	return TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CDataFile::WriteBinaryFileThread2
//----------------------------------------------------------------------------------------------------
//  2. @\
//		t@C݃Xbh̖{
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CProgressBar	*pProgressBar	[I] vOXo[NXւ̃|C^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	TRUEF@FALSEFG[
//*****************************************************************************************************
BOOL CDataFile::WriteBinaryFileThread2(CProgressBar *pProgressBar)
{
	CFile cWFile;
	int	i, nWrite;
	CString str, sText;

	// ݃t@CI[v
	if (!cWFile.Open(m_WriteFilePath, CFile::modeCreate | CFile::modeWrite | CFile::shareDenyWrite)) {
		CGeneral::Alert("݃t@C܂B");
		return FALSE;
	}

// 077FD050-GYM961-0_007 2007/9/8 appended by yG ->
	// CSVt@C̐擪Ɍvt
	str.Format(m_nDataType == DATA_TYPE_MMA ? "TAA ID:%d\n" : "Sensor ID:%d\n", m_nSensorId);
	cWFile.Write(str, str.GetLength());
	str.Format("Time Zero:%s\n", m_dStarttime.GetStr());
	cWFile.Write(str, str.GetLength());
	str.Format("Sampling Rate:%.2f[Hz]\n", m_fSampleRate);
	cWFile.Write(str, str.GetLength());
	if (m_nDataType == DATA_TYPE_MMA) {
		str.Format("Cut Off Freq:%d[Hz]\n", m_nCutoff);
		cWFile.Write(str, str.GetLength());
		str.Format("Gain:%d\n", m_nGain);
		cWFile.Write(str, str.GetLength());
	}
	str.Format("Sensor Position:%s\n", m_SensorPos);
	cWFile.Write(str, str.GetLength());
// 077FD050-GYM961-0_007 2007/9/8 appended by yG <-

	if (m_bTempOnly)
		str = gTitleTemp;
	else {
		switch (m_nDataType) {
		case DATA_TYPE_MMA:
			str = gTitleMma;
			break;
		case DATA_TYPE_MME:
			str = gTitleMme;
			break;
		case DATA_TYPE_ASU:
			str = gTitleAsu;
			break;
		}
	}
	cWFile.Write(str, str.GetLength());
	nWrite = 0;

	// CSVt@CɃf[^o
	if (m_bTempOnly)	// xf[^̂
	{
		for (i = 0; i < m_nDataSize; i += (m_nDownRate*40)) {
			CDataDateTime Begin;
			Begin.SetTime(m_dStarttime.m_YY
				, m_dStarttime.m_MM
				, m_dStarttime.m_DD
				, (int)((m_nBeginTime + i / m_fSampleRate) * 1000));
			sText = Begin.GetStrYMD();
			sText += CGeneral::FormatTime(m_nBeginTime + i / m_fSampleRate, 4);
			str.Format("%d,%s,%f,%f,%f,%f\n", nWrite + 1
				, sText
				, m_pTempDACM[i]
				, m_pTempX[i]
				, m_pTempY[i]
				, m_pTempZ[i]);
			cWFile.Write(str, str.GetLength());

			if ((nWrite % 10000) == 0) {
				// vOXo[XV
				if (!pProgressBar->SetProgress(nWrite * 10 / (m_nDataSize / (m_nDownRate*40)) + 1)) {
					// f[^t@CN[Y
					cWFile.Close();
					return FALSE;
				}
			}
			nWrite++;
		}
	}
	else	// Sf[^
	{
		for (i = 0; i < m_nDataSize; i += m_nDownRate) {
			CDataDateTime Begin;
			Begin.SetTime(m_dStarttime.m_YY
				, m_dStarttime.m_MM
				, m_dStarttime.m_DD
				, (int)((m_nBeginTime + i / m_fSampleRate) * 1000));
			sText = Begin.GetStrYMD();
			sText += CGeneral::FormatTime(m_nBeginTime + i / m_fSampleRate, 4);
			switch (m_nDataType) {
			case DATA_TYPE_MMA:
				str.Format("%d,%s,%f,%f,%f,%f,%f,%f,%f\n", nWrite + 1
					, sText
					, m_pDataX[i]
					, m_pDataY[i]
					, m_pDataZ[i]
					, m_pTempDACM[i]
					, m_pTempX[i]
					, m_pTempY[i]
					, m_pTempZ[i]);
				break;
			case DATA_TYPE_MME:
			case DATA_TYPE_ASU:
				str.Format("%d,%s,%f,%f,%f\n", nWrite + 1
					, sText
					, m_pDataX[i]
					, m_pDataY[i]
					, m_pDataZ[i]);
				break;
			}
			cWFile.Write(str, str.GetLength());

			if ((nWrite % 10000) == 0) {
				// vOXo[XV
				if (!pProgressBar->SetProgress(nWrite * 10 / (m_nDataSize / m_nDownRate) + 1)) {
					// f[^t@CN[Y
					cWFile.Close();
					return FALSE;
				}
			}
			nWrite++;
		}
	}
	// f[^t@CN[Y
	cWFile.Close();

	pProgressBar->SetProgress(10);

	AfxMessageBox("CSVt@Cւ̏o͂܂B",MB_ICONINFORMATION|MB_OK);

	return TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CDataFile::AllocBuf
//----------------------------------------------------------------------------------------------------
//  2. @\
//		oCif[^obt@mۏ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CDataFile::AllocBuf()
{
	if (m_nDataSize <= m_nAllocSize)
		return;

	int nAllocSize = (int)(m_nDataSize * m_fAllocFactor);

	// xf[^obt@m
	if (m_bReadAccelData) {
		m_pDataX = ReallocBuf(m_pDataX, m_nAllocSize, nAllocSize);
		m_pDataY = ReallocBuf(m_pDataY, m_nAllocSize, nAllocSize);
		m_pDataZ = ReallocBuf(m_pDataZ, m_nAllocSize, nAllocSize);
	}

	// xf[^obt@m
	if (m_bReadTempData) {
		m_pTempDACM = ReallocBuf(m_pTempDACM, m_nAllocSize, nAllocSize);
		m_pTempX = ReallocBuf(m_pTempX, m_nAllocSize, nAllocSize);
		m_pTempY = ReallocBuf(m_pTempY, m_nAllocSize, nAllocSize);
		m_pTempZ = ReallocBuf(m_pTempZ, m_nAllocSize, nAllocSize);
	}

	m_nAllocSize = nAllocSize;
}

//*****************************************************************************************************
//  1. ֐
//		CDataFile::ReallocBuf
//----------------------------------------------------------------------------------------------------
//  2. @\
//		oCif[^obt@Ċmۏ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		double	*pOldBuf	[I] mۍς݂̃obt@|C^
//		int		nOldSize	[I] mۍς݂̃obt@TCY
//		int		nNewSize	[I] Vmۂobt@TCY
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		double*		Vmۂobt@|C^
//*****************************************************************************************************
double *CDataFile::ReallocBuf(const double *pOldBuf, int nOldSize, int nNewSize)
{
	double *pNewBuf = new double[nNewSize];

	if (pOldBuf != NULL) {
		memcpy(pNewBuf, pOldBuf, nOldSize * sizeof(double));
		delete [] pOldBuf;
	}

	return pNewBuf;
}

//*****************************************************************************************************
//  1. ֐
//		CDataFile::FreeBuf
//----------------------------------------------------------------------------------------------------
//  2. @\
//		oCif[^obt@
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CDataFile::FreeBuf()
{
	if (m_pTempDACM != NULL) {
		delete [] m_pTempDACM;
		m_pTempDACM = NULL;
	}

	if (m_pTempX != NULL) {
		delete [] m_pTempX;
		m_pTempX = NULL;
	}

	if (m_pTempY != NULL) {
		delete [] m_pTempY;
		m_pTempY = NULL;
	}

	if (m_pTempZ != NULL) {
		delete [] m_pTempZ;
		m_pTempZ = NULL;
	}

	if (m_pDataX != NULL) {
		delete [] m_pDataX;
		m_pDataX = NULL;
	}

	if (m_pDataY != NULL) {
		delete [] m_pDataY;
		m_pDataY = NULL;
	}

	if (m_pDataZ != NULL) {
		delete [] m_pDataZ;
		m_pDataZ = NULL;
	}
}
